//+------------------------------------------------------------------+
//|                                                Custom WPR_MA.mq4 |
//|                                  Copyright  2014, Balog Mikls. |
//+------------------------------------------------------------------+
#property  copyright "Copyright  2014, Balog Mikls."
//---- indicator settings
#property  indicator_separate_window
#property  indicator_buffers 6
#property indicator_color1 Green
#property indicator_color2 Gold
#property indicator_color3 Aqua
#property indicator_color4 Plum
#property indicator_color5 DarkBlue 
#property indicator_color6 Red 
#property indicator_width1 1
#property indicator_width2 1
#property indicator_width3 1
#property indicator_width4 1
#property indicator_width5 1
#property indicator_width6 2
#property indicator_level1 -5
#property indicator_level2 -95
#property indicator_level3 -20
#property indicator_level4 -50
#property indicator_level5 -80

//---- indicator parameters
 extern int     WPR_Period1=14;
 extern int     WPR_Period2=50;
 extern int     WPR_Period3=100;
 extern int     WPR_Period4=500;
 extern int     WPR_used_first=4;
 extern int     MA_Period=4;
 extern string  m = "--Moving Average Types--";
 extern string  m0 = " 0 = SMA";
 extern string  m1 = " 1 = EMA";
 extern string  m2 = " 2 = SMMA";
 extern string  m3 = " 3 = LWMA";
 extern int       MA_Type=0;
//---- indicator buffers
double     WPR_Buffer1[];
double     WPR_Buffer2[];
double     WPR_Buffer3[];
double     WPR_Buffer4[];
double     WPR_Buffer_main[];
double     MA_Buffer[];

int    MA_Mode;
string strMAType;

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- drawing settings
   SetIndexStyle(0,DRAW_LINE);
   SetIndexStyle(1,DRAW_LINE);
   SetIndexStyle(2,DRAW_LINE);
   SetIndexStyle(3,DRAW_LINE);
   SetIndexStyle(4,DRAW_LINE);
   SetIndexStyle(5,DRAW_LINE);

   SetIndexDrawBegin(1,WPR_Period1);
   SetIndexDrawBegin(2,WPR_Period2);
   SetIndexDrawBegin(3,WPR_Period3);
   SetIndexDrawBegin(4,WPR_Period4);
      
      
   
   IndicatorDigits(Digits+1);
//---- indicator buffers mapping
   SetIndexBuffer(0,WPR_Buffer1);
   SetIndexBuffer(1,WPR_Buffer2);
   SetIndexBuffer(2,WPR_Buffer3);
   SetIndexBuffer(3,WPR_Buffer4);
   SetIndexBuffer(4,WPR_Buffer_main);
   SetIndexBuffer(5,MA_Buffer);
//---- name for DataWindow and indicator subwindow label
switch (MA_Type)
   {
      case 1: strMAType="EMA"; MA_Mode=MODE_EMA; break;
      case 2: strMAType="SMMA"; MA_Mode=MODE_SMMA; break;
      case 3: strMAType="LWMA"; MA_Mode=MODE_LWMA; break;
      default: strMAType="SMA"; MA_Mode=MODE_SMA; break;
   }
   IndicatorShortName( "WPR_MA");
   SetIndexLabel(0,"WPR" + " (" +WPR_Period1 + ") ");
   SetIndexLabel(1,"WPR" + " (" +WPR_Period2 + ") ");
   SetIndexLabel(2,"WPR" + " (" +WPR_Period3 + ") ");
   SetIndexLabel(3,"WPR" + " (" +WPR_Period4 + ") ");
   
   SetIndexLabel(5,"MA" + " (" +MA_Period + ") ");
   //SetIndexLabel(1,strMAType+ " (" + MA_Period + ") ");
//---- initialization done
   return(0);
  }
//+------------------------------------------------------------------+
//| Moving Averages Convergence/Divergence                           |
//+------------------------------------------------------------------+
int start()
  {
   int limit;
   int counted_bars=IndicatorCounted();
   double WPR_ma;
//---- last counted bar will be recounted
   if(counted_bars>0) counted_bars--;
   limit=Bars-counted_bars;
//---- WPR counted in the 1-st buffer
   for(int i=0; i<limit; i++)
   {
      WPR_Buffer1[i]=iWPR(NULL,0,WPR_Period1,i);
      WPR_Buffer2[i]=iWPR(NULL,0,WPR_Period2,i);
      WPR_Buffer3[i]=iWPR(NULL,0,WPR_Period3,i);
      WPR_Buffer4[i]=iWPR(NULL,0,WPR_Period4,i);
      WPR_Buffer_main[i]=(WPR_Buffer1[i]+WPR_Buffer2[i]+WPR_Buffer3[i]+WPR_Buffer4[i])/4;
    }
//---- MA line counted in the 2-nd buffer
   for(i=0; i<limit; i++)
     // MA_Buffer[i]=iMAOnArray(WPR_Buffer_main,Bars,MA_Period,1,MA_Mode,i);
      MA_Buffer[i]=(iMAOnArray(WPR_Buffer1,Bars,MA_Period,1,MA_Mode,i)+iMAOnArray(WPR_Buffer2,Bars,MA_Period,1,MA_Mode,i)+iMAOnArray(WPR_Buffer3,Bars,MA_Period,1,MA_Mode,i)+iMAOnArray(WPR_Buffer4,Bars,MA_Period,1,MA_Mode,i))/4;
//---- done
   return(0);
  }
//+------------------------------------------------------------------